# Link tham khao:
# https://integratedmlai.com/find-the-determinant-of-a-matrix-with-pure-python-without-numpy-or-scipy/

# Nhap kich thuoc ma tran
while True:
    n = int(input("Nhap kich thuoc ma tran (n>=2): "))
    if n >= 2:
        break

print("Nhap ma tran: ")  # Nhap ma tran
matrix = []
for i in range(n):
    a = []
    for j in range(n):
        while True:
            print("A[", i, "][", j, "]: ", end="")
            num = int(input())
            if num <= 50 and num >= -50:
                a.append(num)
                break
    matrix.append(a)


def det_matrix(matrix, total=0):  # Tinh dinh thuc cua ma tran
    indices = list(range(len(matrix)))
    if len(matrix) == 2 and len(matrix[0]) == 2:
        val = matrix[0][0] * matrix[1][1] - matrix[1][0] * matrix[0][1]
        return val  # Tinh dinh thuc cua ma tran 2x2

    for fc in indices:  # Lap qua cac cot
        As = matrix  # Tao ma tran con
        As = As[1:]
        height = len(As)  # Chieu cao ma tran con
        for i in range(height):
            As[i] = As[i][0:fc] + As[i][fc+1:]  # Xoa cot fc
        sign = (-1) ** (fc % 2)  # Chon dau
        sub_det = det_matrix(As)  # Tinh dinh thuc cua ma tran con
        total += sign * matrix[0][fc] * sub_det  # Cong don

    return total  # Tra ve dinh thuc cua ma tran


print("Dinh thuc cua ma tran: ", det_matrix(matrix))