# Square minimum method
import numpy as np


def sqMin(a):
    b = []
    o1 = []
    for i in range(len(a)):
        o1.append(1.0)
        b.append((i + 1) * 1.0)

    x = np.array([o1, b])
    u = np.dot(x, x.T)
    y = np.array(a)

    u_1 = np.linalg.inv(u)
    v = np.dot(u_1, x)
    A = np.dot(v, y)
    return A


data = [10.0, 8.0, 7.0, 5.0, 2.0]
print(sqMin(data))
