# Linear Mapping
import sympy as sp
import numpy as np

a, b = sp.symbols("a b")
x, y = sp.symbols("x y")

print(sp.solve([a + 3 * b - x, 2 * a + 5 * b - y], [a, b]))

fu1 = np.array([1, 1, 2])
fu2 = np.array([4, 2, 1])
fu = a * fu1 + b * fu2
print(fu)

fu = a.subs(a, -5 * x + 3 * y) * fu1 + b.subs(b, 2 * x - y) * fu2
print(fu)
